/* Copyright (c) 2014 by Boris van Schooten tmtg.net boris@13thmonkey.org */
// Released under BSD license. See LICENSE for details.

// constants

var width=1920, height=1080;

var gamebasespeed = 1000/60;



// vars

var eng;

//var ld33bg;

var gl;

var lastTime = 0;
var timeElapsed = 1000/60;
var expectedTimeElapsed = 1000/60;
var gametime=0, gamespeed=1.0, totalgametime=0;

var frameskip=0;

var level=0, stage=0, lives=3;

var startlevel=0;

var leveltimer=1000;

var score=0;

var swipesensitivity = 2.5;
var gamepadsensitivity = 8;

var cyclecol = [
	[1, 0.5, 0.5, 1],
	[1, 1, 0.5, 1],
	[0.5, 1, 0.5, 1],
	[0.5, 1, 1, 1],
	[0.5, 0.5, 1, 1],
	[1, 0.5, 1, 1],
];

var gamepadcontrols = false;
var touchcontrols = false;

var gamepadmx = 0;
var gamepadmy = 0;
var gamepadfx = 0;
var gamepadfy = 0;

var gamepaddx = 0;
var gamepaddy = 0;

var gamepadbut = false;
var prevgamepadbut = false;

var spritesheet_tex;
var particlesheet_tex;
var font_tex;
var tiles_tex;

var bg_texs = [];

var spritebatch, particlebatch, fontbatch;


var tilemap;
var screenxofs = 0;
var screenyofs = 0;
var tilex=60;
var tiley=60;


var unit_arrow = [
	0, -1,
	-1,0,
	-0.5,0,
	-0.5,1,
	0.5,1,
	0.5,0,
	1,0,
];


var font_color = [1,1,1,1];

var mainmenu;
var curmenu;



var token=null;

var persistentstate=null;

var GameState = {
	levels: {} /* levelnr: { complete:true, score: 0 } */

}

var gamestate_loaded=false;





function resizeCanvas() {
	var canvas = document.getElementById("game-canvas");
	canvas.style.width = window.innerWidth;
	canvas.style.height = window.innerHeight;
	canvas.width = window.innerWidth;
	canvas.height = window.innerHeight;
}

function webGLStart() {
	//if (window.navigator.paymentSystem) 
	//	window.navigator.paymentSystem.init("f2ab665e-217f-41fc-98d6-bbdaa6ced57c");
	window.addEventListener('resize', resizeCanvas, false);
	// init gl
	var canvas = document.getElementById("game-canvas");
	resizeCanvas();
	gl = createGL(canvas, {antialias:false, premultipliedAlpha: false});
	// use this to show verbose debug info in console
	//gl = WebGLDebugUtils.makeDebugContext(gl);

	eng = new JGEngine(canvas,width,height);
	eng.setGameState("Loading",-1);
	//eng.setGameState("Game",-1);
	//eng.setGameState("NewLevel",450);

	gldrawInit();

	//ld33bg = new CustomBG();
	gamestate_loaded=true;

	//JGAudio.load("error","sounds/164245__soniktec__metallic-sound-pack-1_cc_0");

	tiles_tex = initTexture(gl,"images/ld34sprites.png",false,false);
	spritesheet_tex=initTexture(gl,"images/ld34sprites.png",false,false);
	//particlesheet_tex = initTexture(gl,"images/candyparticles-2.png",true,false);
	//bg_texs.push(initTexture(gl,GameConfig.textures.bg,true,false));

	font_tex = initTexture(gl,"images/cellfontdejavusansmono-outline.png",true,false);

	spritebatch = new JGSpriteBatch(gl,spritesheet_tex,
		100,100, [
		{x: 0,y: 0, width: 10, height: 10
		}
	] );

	//particlebatch = new JGSpriteBatch(gl,particlesheet_tex,1024,1024, [
	//	{x: 0,y: 0, width:256,height:256}
	//] );

	fontbatch = new JGSpriteBatch(gl,font_tex,512,512, [
		{x: 0,y: 0, width:32,height:48}
	] );


	//if (!music_started) {
	//	JGAudio.play("music","music",true);
	//	music_started=true;
	//}


	// create menus
	mainmenu = new JGMenu(drawLogo);
	mainmenu.addMenuItem(drawMenuItemStatic,selMenuStartGame,
		{ ypos: 350, text: "Start Game" });
	mainmenu.addMenuItem(drawMenuItemLevel,selMenuLevel,{ypos: 450});
	//mainmenu.addMenuItem(drawMenuItemSound,selMenuSound,{ypos: 500});
	//mainmenu.addMenuItem(drawMenuItemMusic,selMenuMusic,{ypos: 600});
	//mainmenu.addMenuItem(drawMenuItemDonate,selMenuDonate,{ypos: 700});

	var optionsmenu = new JGMenu(null,drawMenuItemStatic,
		{ ypos:650, text: "<<< Back" });
	mainmenu.addSubmenu(drawMenuItemStatic,optionsmenu,
		{ ypos:550, text: "Options" });
	optionsmenu.addMenuItem(drawMenuItemSound,selMenuSound,{ypos:350});
	optionsmenu.addMenuItem(drawMenuItemMusic,selMenuMusic,{ypos:450});
	optionsmenu.addMenuItem(drawMenuItemTouch,selMenuTouch,{ypos:550});

	//var creditsmenu = new JGMenu(drawCredits,drawMenuItemStatic,
	//	{ ypos:490, text: "BACK" });
	//mainmenu.addSubmenu(drawMenuItemStatic,creditsmenu,
	//	{ ypos:390, text: "CREDITS" });

	/*if (window.navigator.paymentSystem 
	&& window.navigator.paymentSystem.getType()=="ouya") {
		window.navigator.paymentSystem.init(
			"f2ab665e-217f-41fc-98d6-bbdaa6ced57c");
		mainmenu.addMenuItem(drawMenuItemDonate,selMenuDonate,{ypos: 450});
	}*/

	// start animation
	webGLFrame();
}

function drawMenuItemStatic(is_active,menu,menuitem) {
	return drawMenuText(is_active,menu,menuitem,menuitem.userdata.text);
}

function drawMenuText(is_active,menu,menuitem,text) {
	var size = is_active ? 15+1*Math.sin(0.1*menu.animtimer) : 13;
	var thick = is_active ? 3.5 : 2.0;
	drawSpriteText(fontbatch,text,width/2, menuitem.userdata.ypos,
		5*size,5*size, 0, 0.25);
	return {x:width/6, width:2*width/3, y:menuitem.userdata.ypos-25, height:70};
}

function selMenuStartGame(menu) {
	eng.setGameState("Game",-1);
	eng.addGameState("NewLevel",450);
}


function drawMenuItemLevel(is_active,menu,menuitem) {
	return drawMenuText(is_active,menu,menuitem, "Start at level "+(startlevel+1));
}

function selMenuLevel(menu) {
	startlevel++;
	if (startlevel >= 12) startlevel = 0;
}

function drawMenuItemDonate(is_active,menu,menuitem) {
	var st = window.navigator.paymentSystem.checkReceipt("super_pyro_runner_donation_0_99");
	return drawMenuText(is_active,menu,menuitem, st==1
		? "THANKS FOR YOUR DONATION!"
		: (st==-1  ? "DONATE $0.99" : "") );
}

function selMenuDonate(menu) {
	window.navigator.paymentSystem.requestPayment("super_pyro_runner_donation_0_99");
}


function drawMenuItemSound(is_active,menu,menuitem) {
	return drawMenuText(is_active,menu,menuitem, "Sound " +
		(JGAudio.isEnabled() ? "Enabled" : "Disabled") );
}

function selMenuSound(menu) {
	if (JGAudio.isEnabled()) {
		JGAudio.disable();
	} else {
		JGAudio.enable();
	}
}
function selMenuMusic(menu) {
	if (JGAudio.isEnabled("music")) {
		JGAudio.disable("music");
	} else {
		JGAudio.enable("music");
		//JGAudio.play("music","music",true);
	}
}

function drawMenuItemMusic(is_active,menu,menuitem) {
	return drawMenuText(is_active,menu,menuitem, "Music " +
		(JGAudio.isEnabled("music") ? "Enabled" : "Disabled") );
}

function drawMenuItemTouch(is_active,menu,menuitem) {
	return drawMenuText(is_active,menu,menuitem, "Touch sensitivity "
		+ swipesensitivity);
}

function selMenuTouch(menu) {
	swipesensitivity += 0.5;
	if (swipesensitivity >= 4.5) swipesensitivity = 1.5;
}


function drawLogo(menu) {
	//drawText("A TMTG.NET GAME",width/2,155,8,8,2,font_color,0,0.5);;
}

function drawCredits(menu) {
	drawText("GAME BY LOVE APPLE GAMES",width/2,170,14,14,2.5,font_color,0,0.5);
}


function webGLFrame() {
	// anim handling

	requestGLFrame(webGLFrame);

	var timeNow = new Date().getTime();
	if (lastTime != 0) {
		timeElapsed = timeNow - lastTime;
		gamespeed = timeElapsed / gamebasespeed;
		gamespeed = 1.0;
		gametime += gamespeed;
		totalgametime += gamespeed;
	}
	lastTime = timeNow;
	if (timeElapsed >= 1000/32) {
		frameskip=1;
		doWebGLFrame();
		lastTime = new Date().getTime();
	}
	frameskip=0;
	doWebGLFrame();
}

function doWebGLFrame() {

	// update touch controls
	touchcontrols = eng.sawTouchEvents();

	// read gamepads
	prevgamepadbut = gamepadbut;
	gamepadcontrols = false;
	gamepadmx = 0;
	gamepadmy = 0;
	gamepadfx = 0;
	gamepadfy = 0;
	gamepadbut = false;
	if (navigator.getGamepads) {
		var pads = navigator.getGamepads();
		// circumvent error in Chrome, which returns an array-like
		// thing on desktop that doesn't actually contain elements
		if (pads.length > 0 && pads[0]) {
			gamepadcontrols = true;
			// add up all values from all axes
			for (var i=0; i<pads.length; i++) {
				// circumvent possible errors
				if (!pads[i] || !pads[i].axes || !pads[i].buttons) continue;
				if (pads[i].axes[0] > 0.25 || pads[i].axes[0] < -0.25)
					gamepadmx += pads[i].axes[0];
				if (pads[i].axes[1] > 0.25 || pads[i].axes[1] < -0.25)
					gamepadmy += pads[i].axes[1];
				if (pads[i].axes[2] > 0.25 || pads[i].axes[2] < -0.25)
					gamepadfx += pads[i].axes[2];
				if (pads[i].axes[3] > 0.25 || pads[i].axes[3] < -0.25)
					gamepadfy += pads[i].axes[3];
				for (var b=0; b<4; b++) {
					if (pads[i].buttons[b].pressed) gamepadbut=true;
				}
				gamepaddx = 0;
				gamepaddy = 0;
				if (pads[i].buttons[12].pressed) gamepaddy = -1;
				if (pads[i].buttons[13].pressed) gamepaddy =  1;
				if (pads[i].buttons[14].pressed) gamepaddx = -1;
				if (pads[i].buttons[15].pressed) gamepaddx =  1;
			}
		}
	}



	// init gl

	gl.clearColor(0.0, 0.0, 0.0, 1.0);
	gl.disable(gl.DEPTH_TEST);
	gl.disable(gl.BLEND);
	//gl.blendFunc(gl.ONE, gl.ONE_MINUS_SRC_ALPHA);
	//gl.blendFunc(gl.SRC_ALPHA, gl.ONE_MINUS_SRC_ALPHA);
	gl.blendFunc(gl.SRC_ALPHA, gl.ONE);
	//gl.blendEquationSeparate(gl.FUNC_ADD, gl.FUNC_ADD);
	//gl.blendFuncSeparate(gl.SRC_ALPHA, gl.ONE_MINUS_SRC_ALPHA,
	//	gl.SRC_ALPHA, gl.ONE_MINUS_SRC_ALPHA);
	// clear entire canvas
	gl.viewport(0, 0, gl.canvas.width, gl.canvas.height);
	gl.clear(gl.COLOR_BUFFER_BIT);
	//gl.clear(gl.COLOR_BUFFER_BIT | gl.DEPTH_BUFFER_BIT);
	// then set viewport to preserve aspect ratio
	eng.updateViewport();
	gl.viewport(eng.viewportxofs,eng.viewportyofs,eng.viewportwidth,eng.viewportheight);


	drawLineInitFrame(width,height);
	drawLineSegmentsInitFrame(width,height);
	drawSpriteInitFrame(width,height);

	if (eng.inGameState("Game")) {
		//ld33bg.draw(bg_texs[stage%bg_texs.length],gametime);
	}

	if (eng.inGameState("Title")) {
		//ld33bg.draw(bg_texs[0],gametime);
	}

	spritebatch.clear();
	//particlebatch.clear();
	fontbatch.clear();

	// game states:
	// Title - title screen
	// Game - remains active from start game till game over
	// During Game, the following states are found:
	//   NewLevel - start new level sequence
	//   LevelDone - finish current level sequence
	//   NewLife - start with new life sequence
	//   LifeLost - lose life sequence
	//   GameOver - game over sequence
	eng.handleGameStates(1,frameskip);

	if (!frameskip) {
		var pointerx = eng.getMouseX();
		var pointery = eng.getMouseY();
		font_color = 
			[0.5+0.5*Math.sin(gametime*0.2),
			 0.5+0.5*Math.sin(gametime*0.164),
			 0.5+0.5*Math.sin(gametime*0.111), 1];
		/*if (eng.inGameState("Title")) {
			font_color = [0,0,0,1];
		} else if (stage%4==2) {
			font_color = [1,1,1,1];
		} else {
			font_color = [0,0,0,1];
		}*/
		//drawSpriteText(fontbatch,""+score,100,60,40,40,-1,0.25);
		//drawSpriteText(fontbatch,""+leveltimer,width/2,60,40,40,0,0.25);

		// mouse cursor

		var ang = Math.PI + Math.PI/4;
		var player = null;//JGObject.getObject("player");
		if (player) {
			if (player.fireofsx!=0 || player.fireofsy!=0) {
				pointerx = player.x + player.fireofsx - screenxofs;
				pointery = player.y + player.fireofsy - screenyofs;
				//console.log("######"+pointerx+" "+pointery);
			}
			ang = Math.atan2(pointerx - player.x + screenxofs,
							 pointery - player.y);
		}
		if (!gamepadcontrols && !touchcontrols) {
			var color = hsv_to_rgb(gametime/100,0.7,1, 1);
			//var color = cyclecol[Math.floor(gametime/8) % cyclecol.length];
			//particlebatch.addSprite(0,pointerx,pointery,true,
			//	96, 96, 0.0, color);
			//gl.enable(gl.BLEND);
			//drawLine([pointerx,pointery], Math.PI-ang, 20.0, 4,
			//	color, unit_arrow, unit_arrow.length/2, true, "unit_arrow");
			//gl.disable(gl.BLEND);
		}

		gl.enable(gl.BLEND);
		gl.blendFunc(gl.SRC_ALPHA, gl.ONE_MINUS_SRC_ALPHA);
		spritebatch.draw(gl);
		//particlebatch.draw(gl);
		fontbatch.draw(gl);
		gl.disable(gl.BLEND);
		//gl.blendFunc(gl.SRC_ALPHA, gl.ONE);
		//gl.blendFunc(gl.ONE, gl.ONE_MINUS_SRC_ALPHA);
		//gl.blendFunc(gl.SRC_ALPHA, gl.ONE_MINUS_SRC_ALPHA);

	}

}

function checkTime(start,end,period) {
	return (gametime >= start && gametime < end && gametime%period<gamespeed);
}


// game states: transitions

var music_started=false;


// --------------------------------------------------------------------
// game state NewLevel


var thislevel=null;

var nr_towards_goal=0;

function startNewLevel(timer) {
	gametime=0;
	score = 0;
	JGObject.removeObjects(null,0);
	tilemap = new JGTileMap(gl, tilex,tiley, 32,18,-1,0, tiles_tex, 12,12,12,12);
	tilemap.setOffscreenTile(0,1);
	for (var x=0; x<tilemap.nrtilesx; x++) {
		//tilemap.setTile(32,1,x,0);
	}
	for (var y=0; y<tilemap.nrtilesy; y++) {
		//tilemap.setTile(32,1,0,y);
	}
	tilemap.update(gl);
}


function paintFrameNewLevel(timer) {
	var ea = texteasing(timer);
	var col = [font_color[0],font_color[1],font_color[2],ea.alpha];
	//drawSpriteText(fontbatch,"Get Ready!",width/2,450,90*ea.size,90*ea.size,0, 0.25,col);
	drawSpriteText(fontbatch,"Level "+(stage+1),width/2,150,90*ea.size,90*ea.size,0,0.25,col);
	printInstructions(ea,col);
}


// --------------------------------------------------------------------
// game state Game


function startGame(timer) {
	//if (window.navigator.paymentSystem) 
	//	window.navigator.paymentSystem.requestPayment("tsunami_cruiser_donate_0_99");
	score = 0;
	level = startlevel;
	stage = startlevel;
	lives = 3;
}


function doFrameGame(timer) {
	// update state

	if (!frameskip) {
		//var col = 0.5 + 0.5*Math.sin(gametime*0.05);
		gl.disable(gl.BLEND);
		drawSprite(0,0,width,height, 0.0, 
			bg_texs[0],
			null,
			null, true);
		tilemap.draw(gl,screenxofs,screenyofs);
	}
	JGObject.updateObjects(gl,frameskip,screenxofs,screenyofs,width,height);

	//JGObject.checkCollision(2,4);
	//JGObject.checkBGCollision(tilemap,255,1+2+4+8); // all tiles hit all


	//if (checkTime(0,4000,Math.floor(220 - 9*level))) {
	//}
	if (eng.getKey("L")) eng.addGameState("LevelDone",150);
	//if (gametime>=3000 && JGObject.countObjects("walker",0) == 0) {
	//	eng.addGameState("LevelDone",150);
	//}
	//nr_bankers = JGObject.countObjects("flower",0);
	leveltimer--;
	//if (leveltimer<=0) {
		//if (nr_bankers == 0) {
		//	eng.addGameState("LevelDone",150);
		//}
	/*} else {
		leveltimer--;
		if (checkTime(200,2000,200-level*5)) {
			//createInvaders(5+level);
		}
		if (leveltimer<=0 || JGObject.countObjects("missile",0)==0) {
		//	eng.addGameState("GameOver",150);
		}
	}*/
}

function paintFrameGame(timer) {
}

// --------------------------------------------------------------------
// game state Loading

function paintFrameLoading(timer) {
	drawSpriteText(fontbatch,"Please wait ...",width/2,450,90,90,0, 0.25,[1,1,1,1]);
}

function doFrameLoading(timer) {
	if (gamestate_loaded) {
		eng.setGameState("Title",-1);
	}
}


// --------------------------------------------------------------------
// game state Title


function startTitle(timer) {
	curmenu = mainmenu;
	JGObject.removeObjects(null,0);
}


function doFrameTitle(timer) {
	curmenu = curmenu.update(!gamepadcontrols,eng.getMouseX(),eng.getMouseY(),
		(eng.getMouseButton(1) && !touchcontrols && !gamepadcontrols)
		|| (!gamepadcontrols && eng.touches.length>0),
			gamepadmy<-0.7 || gamepadfy<-0.7 || gamepaddy < -0.5,
			gamepadmy> 0.7 || gamepadfy> 0.7 || gamepaddy > 0.5,
			gamepadbut);
	JGObject.updateObjects(gl,frameskip,screenxofs,screenyofs,width,height);
}

function paintFrameTitle(timer) {
	curmenu.paint();
	if (!frameskip) {
		//var col = 0.5 + 0.5*Math.sin(gametime*0.05);
		gl.disable(gl.BLEND);
		drawSprite(0,0,width,height, 0.0, 
			bg_texs[0],
			null,
			null, true);
	}
}

// --------------------------------------------------------------------
// game states: MISC


function texteasing(timer) {
	if (timer < 20) return {size:1, alpha: timer/20};
	if (timer < 400) return {size:1, alpha:1.0};
	return {
		size: 1.5 + 3*((timer-400)/30),
		alpha: 1.0// - (timer-110)/20
	};
}

function paintFrameNewLife(timer) {
}

function paintFrameLifeLost(timer) {
	drawSpriteText(fontbatch,"TRY AGAIN!",width/2,300,30,30,0,0.25);
}


function startLifeLost(timer) {
}

function endLifeLost(timer) {
	lives--;
	if (lives<=0) {
		eng.addGameState("GameOver",200);
	} else {
		eng.addGameState("NewLife",150);
	}
}



// --------------------------------------------------------------------
// game state GameOver

function startGameOver(timer) {
	JGAudio.play("failure");
	new MenuObj(9, width/2 - 200,height/2, 384,384, 0, "opnieuw",170,0.15,
	function(args) {
		eng.removeGameState("GameOver");
		eng.addGameState("NewLevel",450);
	}, {});
	new MenuObj(10, width/2 + 200,height/2, 384,384, 0, "naar menu",170,0.15,
	function(args) {
		eng.setGameState("Title",-1);
	}, {});
}

function paintFrameGameOver(timer) {
	var ea = texteasing(20);
	var col = [font_color[0],font_color[1],font_color[2],ea.alpha];
	drawSpriteText(fontbatch,"Mislukt",width/2,150,90*ea.size,90*ea.size,
		0,0.25,col);
}



// --------------------------------------------------------------------
// game state LevelDone

function startLevelDone(timer) {
}

function paintFrameLevelDone(timer) {
	var ea = texteasing(20);
	var col = [font_color[0],font_color[1],font_color[2],ea.alpha];
	drawSpriteText(fontbatch,"Level complete!",width/2,150,90*ea.size,90*ea.size,0,0.25,col)
}




// --------------------------------------------------------------------
// Text Particle
// --------------------------------------------------------------------

function TextObj(text,color,x,y,startsize,endsize,duration) {
	JGObject.apply(this,["particle",true,x,y, 0]);
	this.text = text;
	this.color = color;
	this.expiry = duration;
	this.maxexp = this.expiry;
	this.size = startsize;
	this.grow = (endsize-startsize) / duration;
}

TextObj.prototype = new JGObject();

TextObj.prototype.move = function() {
	this.expiry--;
	if (this.expiry<=0) this.remove();
	this.size += this.grow;
}

TextObj.prototype.hit = function(obj) { }

TextObj.prototype.hit_bg = function(tilecid) { }


TextObj.prototype.paint = function(gl) {
	var phase = this.expiry/this.maxexp;
	if (phase>0) phase = Math.sqrt(phase);
	var col = [this.color[0],this.color[1],this.color[2],
				this.color[3]*phase];
	drawSpriteText(fontbatch,this.text,this.x,this.y-0.0*this.size,
		this.size,this.size,0,0.25,col);
}

// --------------------------------------------------------------------
// Particle
// --------------------------------------------------------------------

function createExplo(x,y,size,type) {
	for (var i=0; i<size; i++) {
		new Particle(type,random(x-30,x+30),random(y-30,y+30),50);
	}
}

function Particle(type,x,y,size) {
	JGObject.apply(this,["particle",true,x,y, 0]);
	this.type = type;
	this.expiry = random(0.5*size,size);
	this.maxexp = this.expiry;
	this.xspeed = random(-6,6);
	this.yspeed = random(-7,4);
	this.ang = random(0,6.2);
	this.timer = random(0,2);
	this.size = (this.type==0 ? 1.0 : 1.5)*random(1.25*size,2.5*size);
}

Particle.prototype = new JGObject();

Particle.prototype.move = function() {
	this.expiry--;
	if (this.expiry<=0) this.remove();
	this.yspeed += 0.2;
	this.ang += (this.type==0 ? 0.04 : 0.01)*this.xspeed;
	this.timer += this.type==0 ? 0.01 : 0.5;
}


Particle.prototype.hit = function(obj) { }

Particle.prototype.hit_bg = function(tilecid) { }


Particle.prototype.paint = function(gl) {
	var phase = this.expiry/this.maxexp;
	if (phase>0) phase = Math.sqrt(phase);
	var col;
	if (this.type==0) {
		col = hsv_to_rgb(this.timer,1,1, phase);
	} else {
		col = hsv_to_rgb(0.1+Math.sin(this.timer)*0.1,this.timer%1,1, phase);
		phase = Math.sqrt(phase);
	}
	//particlebatch.addSprite(3+this.type,this.x,this.y,false,
	//	this.size, this.size, this.ang, col);
}


